<html
    xmlns:f="http://typo3.org/ns/TYPO3/CMS/Fluid/ViewHelpers"
    xmlns:be="http://typo3.org/ns/TYPO3/CMS/Backend/ViewHelpers"
    xmlns:sv="http://typo3.org/ns/T3graf/Smartverein/ViewHelpers"
    xmlns:core="http://typo3.org/ns/TYPO3/CMS/Backend/ViewHelpers"
    data-namespace-typo3-fluid="true">

<f:layout name="Default" />

<f:section name="Content">
    <f:flashMessages />

    <div class="btn-toolbar justify-content-between" role="toolbar" aria-label="" style="margin-bottom: 10px;">
        <div>
            <be:link.newRecord class="btn btn-warning btn-md t3js-editform-close" title="ll:add new member" table="tx_smartverein_domain_model_members" returnUrl="{f:be.uri(route: 'SmartvereinSvtools_SmartvereinMembers')}" pid="{storagePid}">
                <i class="fa-solid fa-user-plus"></i> <f:translate key="labels.button.newMember"/>
            </be:link.newRecord>
        </div>


        <div  class="ms-auto datatable-right-buttons-parent">
            <div class="dropdown datatable-right-buttons-child" id="table-button">
                <button class="btn btn-default btn-md dropdown-toggle table-controls-button"  type="button" id="adaptColumnsButton" data-bs-toggle="dropdown"  aria-expanded="false">
                    <i class="fa-solid fa-wrench"></i>&nbsp;<f:translate key="labels.button.adaptColumns"/>
                </button>
                <ul class="controls-dropdown-box dropdown-menu"  id="controls-dropdown-menu" aria-labelledby="adaptColumnsButton">

                </ul>
            </div>

            <div  class="datatable-right-buttons-child">
                <a class="btn btn-default btn-md dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                    <f:translate key="labels.button.actions"/>
                </a>

                <ul class="dropdown-menu">
                    <li><a class="dropdown-item disabled" href="#"><i class="fa-solid fa-file-import"></i>&nbsp;Import CSV</a></li>
                    <li><hr class="dropdown-divider"></li>
                    <li><a class="dropdown-item disabled" href="#"><i class="fa-solid fa-file-pdf"></i>&nbsp;Export PDF</a></li>
                    <li><f:link.action action="beDownloadCsv" class="dropdown-item"><i class="fa-solid fa-file-csv"></i>&nbsp;Export CSV</f:link.action></li>
                    <li><f:link.action action="beDownloadVCards" class="dropdown-item"><i class="fa-solid fa-address-card"></i>&nbsp;Export vCards</f:link.action></li>
                </ul>
            </div>
        </div>
</div>
        <table id="members" class="tx_smartclub table table-striped">
            <thead>
            <tr>
                <th><f:translate key="members.profile_image"/></th>
                <th><f:translate key="members.member_number"/></th>
                <th><f:translate key="members.address" /></th>
                <th data-format="{settings.formats.date}"><f:translate key="members.birthday" /></th>
                <th><f:translate key="members.street_address" /></th>
                <th><f:translate key="members.contacts" /></th>
                <th data-format="{settings.formats.date}"><f:translate key="members.entrydate" /></th>
                <th data-format="{settings.formats.date}"><f:translate key="members.leavingdate" /></th>
                <th><f:translate key="members.sections" /></th>
                <th><f:translate key="members.functions" /></th>
                <th><f:translate key="members.positions" /></th>
                <th></th>
            </tr>
            </thead>
            <tbody>
            <f:comment>
                <f:debug>{members}</f:debug>
            </f:comment>

            <f:for each="{members}" as="member">

                <tr>
                    <td class="text-center"> <f:if condition="{member.profileImage}">
                        <f:then>
                            <f:image class="img-fluid profileImage mx-auto d-block" image="{member.profileImage}" height="50px" width="50px"/>
                        </f:then>
                    </f:if>
                    </td>
                    <td>{member.memberId}</td>
                    <td>
                        <f:switch expression="{member.memberType}">
                            <f:case value="0">
                                <f:render partial="Members/Member" arguments="{member:member}"/>
                            </f:case>
                            <f:case value="1">
                                <f:render partial="Members/Organisation" arguments="{member:member}"/>
                            </f:case>
                            <f:defaultCase></f:defaultCase>
                        </f:switch>
                        </td>
                    <td>
                        <f:if condition="{member.dateofbirth}">
                        {member.dateofbirth -> f:format.date(format:'{settings.formats.date}')}<br/>
                            <sv:date.age birthday="{member.dateofbirth -> f:format.date(format:'{settings.formats.date}')}"/>
                    </f:if>

                    </td>
                    <td>
                        <f:render partial="Members/Address" arguments="{member:member}"/>
                        </td>
                    <td>
                        <f:render partial="Members/Contacts" arguments="{member:member}"/>
                    </td>
                    <td>{member.entryDate -> f:format.date(format:'{settings.formats.date}')}
                        <f:if condition="!{member.leavingDate}">
                            <br/><sv:date.MemberSinceYears date="{member.entryDate -> f:format.date(format:'{settings.formats.date}')}"/>
                        </f:if>
                    </td>
                    <td>{member.leavingDate -> f:format.date(format:'{settings.formats.date}')}</td>
                    <td>
                        <f:render partial="Members/Sections" arguments="{member:member}"/>
                    </td>
                    <td>
                        <f:render partial="Members/Functions" arguments="{member:member}"/>
                    </td>
                    <td>
                        <f:render partial="Members/Positions" arguments="{member:member}"/>

                    </td>
                    <td>
                        <f:comment>
                            <f:link.action action="beShowMemberDetails" arguments="{member: member}" class="btn btn-success" title="LL:Show member details"><i class="fa-regular fa-address-card"></i></f:link.action>
                        </f:comment>

                        <be:link.editRecord class="btn btn-success" title="ll:edit member" uid="{member.uid}" table="tx_smartverein_domain_model_members" returnUrl="{f:be.uri(route: 'SmartvereinSvtools_SmartvereinMembers')}">
                            <i class="fa-solid fa-user-pen"></i>
                        </be:link.editRecord>
                        <f:comment>
                            <f:link.action action="beShowMemberDetails" arguments="{member: member}" class="btn btn-danger" title="LL:Delete member"><i class="fa-solid fa-trash-can"></i></f:link.action>
                        </f:comment>
                        </td>
                </tr>
            </f:for>
            </tbody>
        </table>


<f:comment>
    addMember Modal
</f:comment>
    <div class="modal fade" id="addNewMemberModal" tabindex="-1" aria-labelledby="addNewMemberModalLabel" aria-hidden="true">
        <div class="modal-dialog" style="width: 37.5rem;">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="addNewMemberModalLabel">Icon LL:Create a new member</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>

                <f:form action="createNewMember" name="newMember" object="{newMembers}">
                    <div class="modal-body">
                        <h4>LL:Login data</h4>
                        <small><em>Login email address <u>or</u> username for login - unique</em></small>
                        <div class="form-group has-feedback">
                            <input type="email" class="form-control" id="loginEmail" name="email" placeholder="* Login email address or user name for login" value="">
                            <!-- <span class="far fa-fw fa-envelope form-control-feedback g"></span> -->
                        </div>
                        <label><input type="checkbox" name="sendEmail"> Send invitation with a link to choose a password</label>		<br>
                        <h4>LL:Member data</h4>
                        <div class="form-group has-feedback">
                            <input class="form-control" name="memberId" placeholder="Member number" value="311">
                            <!-- <span class="far fa-fw fa-tag form-control-feedback"></span> -->
                        </div>
                        <div class="form-group has-feedback">
                            <input type="text" class="form-control datemask hasDatepicker" name="dateJoined" placeholder="Date of joining" id="dp1677836840407">
                            <!-- <span class="far fa-fw fa-calendar-alt form-control-feedback"></span> -->
                        </div>
                        <hr>
                        <h4>LL:Master data</h4>
                        <div id="addMemberContactMessage" style="display: none;">
                            <em>Data are taken from contact</em>
                        </div>
                        <div id="addMemberContactForms">
                            <f:comment>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group has-feedback">
                                        <input type="text" list="salutation_selection" class="form-control" name="salutation" placeholder="Formal address">
                                        <datalist id="salutation_selection">
                                            <option value="Herr"></option>
                                            <option value="Frau"></option>
                                        </datalist>

                                        <!-- <span class="far fa-fw fa-venus-mars form-control-feedback"></span> -->
                                    </div>
                                </div>
                            </div>
                            </f:comment>
                            <div class="form-group has-feedback">
                                <f:form.textfield class="form-control success" property="firstname" id="firstname" placeholder="* First name"/>
                                <!--input type="text" class="form-control success" name="firstName" placeholder="* First name"-->
                                <!-- <span class="far fa-fw fa-user form-control-feedback g"></span> -->
                            </div>
                            <div class="form-group has-feedback">
                                <f:form.textfield class="form-control" property="surname" id="surname" placeholder="* Surname"/>
                                <!--input type="text" class="form-control" name="familyName" placeholder="* Surname"-->
                                <!-- <span class="far fa-fw fa-users form-control-feedback g"></span> -->
                            </div>
                        </div>
                        <strong>LL:After the new member has been created further data can be added.</strong>

                    </div>

                    <f:comment>
                        <f:link.action action="new" class="btn btn-default">New Members</f:link.action>
                    </f:comment>


                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-bs-dismiss="modal">Close</button>
                    <f:form.submit value="ll:Save member" class="btn btn-danger"/>
                </div>
                </f:form>
            </div>
        </div>
    </div>

    <f:comment>
        JavaScript for Datatables
    </f:comment>
<f:asset.script identifier="membertable-inline">
    require([
    'simpledatatables'
    ], function (simpledatatables) {
    dataTable = new simpledatatables.DataTable("#members",{
    labels: {
    placeholder:"<f:translate id="table.member.placeholder" />",
    searchTitle:"<f:translate id="table.member.searchTitle" />",
    perPage:"<f:translate id="table.member.perPage" />",
    noRows:"<f:translate id="table.member.noRows" />",
    info:"<f:translate id="table.member.info" />",
    noResults:"<f:translate id="table.member.noResults" />"
    },

    columns: [
    // Column Profil image
    { select: 0, sortable: false, },
    // Column MemberID
    { select: 1, sortable: false},
    // Column Name & Overview
    { select: 2, sort:'asc', },
    // Column Birthday
    { select: 3, sortable: false, hidden:true},
    // Column Street Adress
    { select: 4, sortable: false, },
    // Column Contacts
    { select: 5, sortable: false, },
    // Column Entrydate
    { select: 6, sortable: false, },
    // Column Leavingdate
    { select: 7, sortable: false, hidden:true },
    // Column Sections
    { select: 8, sortable: false, hidden:true },
    // Column Functions
    { select: 9, sortable: false, hidden:true },
    // Column positions
    { select: 10, sortable: false, hidden:true },
    // Column Action Buttons
    { select: 11, sortable: false, },
    ]
    });

    var inputs = [], visible = [], hidden = [];
    var checkboxes = document.getElementById("controls-dropdown-menu");
    var tbutton = document.getElementById("table-button");
    //dataTable.headings = window.headings;
    function setCheckboxes() {
    inputs = [];
    visible = [];
    checkboxes.innerHTML = "";
    var fragment = document.createDocumentFragment();
    var isVisible = false;

    document.onclick = function(e){
    if(!tbutton.contains(e.target.parentNode)){
    checkboxes.style.cssText = "display:none;";
    isVisible = false;
    }
    };

    tbutton.onclick = function(e){
    if(checkboxes.contains(e.target)){
    return true;
    }
    if(!isVisible){
    checkboxes.style.cssText = "display:block;";
    isVisible = true;
    }else{
    checkboxes.style.cssText = "display:none;";
    isVisible = false;
    }
    };
    var indx = 0;
    [].forEach.call(dataTable.data.headings, function(heading, i) {

    if (heading.data !== '') {
    var checkbox = document.createElement("li");
    checkbox.className = "dropdown-item";
    var input = document.createElement("input");
    input.type = "checkbox";
    input.id = "checkbox-" + i;
    input.name = "checkbox";
    input.className = "form-check-input"
    var label = document.createElement("label");
    label.htmlFor = "checkbox-" + i;
    label.className = "form-check-label datatable-checkbox-label";
    label.appendChild(

    document.createTextNode(heading.data || heading.innerText)
    );

    // IE 8 supports `Object.defineProperty` on DOM nodes so no p!
    if (Object.defineProperty) {
    Object.defineProperty(input, "idx", {
    value: i,
    writable: false,
    configurable: true,
    enumerable: true
    });
    } else if (input.__defineGetter__) {
    input.__defineGetter("idx", function () {
    return i;
    })
    }
    if (dataTable.columns.visible(indx)) {
    input.checked = true;
    visible.push(i);
    } else {
    if (hidden.indexOf(i) < 0) {
    hidden.push(i);
    }

    }

    checkbox.appendChild(input)
    checkbox.appendChild(label)

    fragment.appendChild(checkbox);

    inputs.push(input);
    }
    indx++;
    });

    [].forEach.call(inputs, function(input, i) {

    input.onchange = function(e) {
    if ( input.checked ) {
    hidden.splice(hidden.indexOf(input.idx), 1);
    visible.push(input.idx);
    } else {
    visible.splice(visible.indexOf(input.idx), 1);
    hidden.push(input.idx);
    }

    updateColumns();
    };
    });

    checkboxes.appendChild(fragment);
    }

    function updateColumns() {
    try {
    dataTable.columns.show(visible);
    dataTable.columns.hide(hidden);
    } catch(e) {
    console.log(e);
    }
    }

    setCheckboxes();
    return dataTable;

    });

</f:asset.script>
</f:section>

</html>
